unit uMain;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,libusb, Spin;
type
  TDevObj = class(TObject)
  public
    Serial:string;
    hDev:pusb_device;
  end;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Button4: TButton;
    Memo1: TMemo;
    edText: TEdit;
    Button2: TButton;
    spX: TSpinEdit;
    spY: TSpinEdit;
    cmdGotoXY: TButton;
    cmdPutAsData: TButton;
    oListe: TListBox;
    Label3: TLabel;
    cmdGotoXY2: TButton;
    cmdCursorOn: TButton;
    cmdCursorOff: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cmdGotoXYClick(Sender: TObject);
    procedure cmdPutAsDataClick(Sender: TObject);
    procedure cmdGotoXY2Click(Sender: TObject);
    procedure cmdCursorOffClick(Sender: TObject);
    procedure cmdCursorOnClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

const
  VENDORID = $16C0;
  PRODUCTID= $05DC;
  CMD_LCDUSB_HOME = 2;
  CMD_LCDUSB_CLEAR= 3;
  CMD_LCDUSB_GOTOXY=4;
  CMD_LCDUSB_DATA = 0;
  CMD_LCDUSB_CMD = 1;
  CMD_LCDUSB_PUTC = 5;

  msgOK =0;
  msgErr =1;

implementation

{$R *.dfm}


procedure TForm1.Button4Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;
  c: byte;
begin
  if (oListe.ItemIndex<0) then
    exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin

//be sitos bybienes neveikia!
c:= ord(edText.Text[1]);

    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN,
        CMD_LCDUSB_CLEAR, 0, 0, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  foundvendor,foundprodukt:boolean;
  buf:array[0..100] of char;
  bus: pusb_bus;
  l:integer;
  dev: pusb_device;
  DevObj:TDevObj;
  hUSB : pointer;
  ProdStr,Serial:string;
begin
  foundvendor:=false;
  foundprodukt:=false;
  usb_init; // Initialize libusb
  memo1.Lines.Add(usb_strerror);
  if(usb_find_busses<1) then
    showmessage(usb_strerror);

  if (usb_find_devices<1) then
    showmessage(usb_strerror); // Find all devices on all USB devices

  bus := usb_get_busses; // Return the list of USB busses found
  if  bus=nil then
    showmessage(usb_strerror);

  while Assigned(bus) do begin
    dev := bus^.devices;
    while Assigned(dev) do begin
      if dev^.descriptor.idVendor=vendorid  then foundvendor:=true;
      if dev^.descriptor.idProduct=productid then foundprodukt:=true;
      if (foundvendor and foundprodukt) then begin
        memo1.Lines.add('ObDev-Device: '+bus.dirname+'/'+dev.filename);
        hUSB := usb_open( dev );
        l := usb_get_string_simple(hUSB,dev.descriptor.iManufacturer,buf,100);
        if l>0 THEN
          memo1.Lines.add('   Manufacturer:'+buf);
          l := usb_get_string_simple(hUSB,dev.descriptor.iProduct,buf,100);
          if l>0 THEN begin
            memo1.Lines.add('   Product id   :'+buf);
            prodStr :=buf;
          end;
          l := usb_get_string_simple(hUSB,dev.descriptor.iSerialNumber,buf,100);
          if l>0 then begin
            memo1.Lines.add('   Serial No.:'+buf);
            serial := buf;
          end else serial:='xx';
          if prodStr='LCD-USB' then begin
            DevObj := TDevObj.Create();
            DevObj.Serial := serial;
            DevObj.hDev := dev;
            oListe.Items.AddObject(serial,DevObj);
          end;
          usb_close(hUSB);
        end;
      dev := dev^.next;
      end;
      bus := bus^.next;
    end;
    if not (foundvendor and foundprodukt) then showmessage('LCD-USB (VID=0x16C0  PID=0x05DC)'+#10+#13+'Not Found');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;
  c:byte;
begin

  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin
  //be sitos bybienes neveikia!
  c:= ord(edText.Text[1]);
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_HOME, 0, 0, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.cmdGotoXYClick(Sender: TObject);    //goto xy
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  x,y:integer;
  c:byte;
  devObj:TDevObj;

begin
  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin
//be sitos bybienes neveikia!
c:= ord(edText.Text[1]);

    x:=spX.Value;
    y:=spY.value;
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_GOTOXY, x, y, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.cmdPutAsDataClick(Sender: TObject);     //write string
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  i:integer;
  c:byte;
  devObj:TDevObj;
begin
  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin
    for i:=1 to length(edText.Text) do begin
      c:= ord(edText.Text[i]);
      usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_PUTC, c, 0, buffer, 0, 1000);
    end;
		usb_close( hUSB );
	end;
end;

procedure TForm1.cmdGotoXY2Click(Sender: TObject);      //gotoxy2
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  c:byte;
  devObj:TDevObj;
  adr,x,y:integer;
begin
  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  adr:=0;
  if ( hUSB <> nil ) then begin
    //be sitos bybienes neveikia!
  c:= ord(edText.Text[1]);
    x:=spX.Value;
    y:=spY.value;
    case y of
      0: adr:=0;
      1: adr:=$40;
      2: adr:=16;
      3: adr:=$50;
    end;
    adr := adr+x;
    memo1.Lines.Add('adr='+IntToStr(adr)+'  x='+IntToStr(x)+' y='+IntTostr(y));
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_CMD, $80 or adr, 0, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.cmdCursorOffClick(Sender: TObject);
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  devObj:TDevObj;
  c:byte;
begin
  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin
  //be sitos bybienes neveikia!
  c:= ord(edText.Text[1]);
    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_CMD, $0C, 0, buffer, 0, 1000);
		usb_close( hUSB );
	end;
end;

procedure TForm1.cmdCursorOnClick(Sender: TObject);     //cursor on
var
  hUSB:pointer;
  buffer:array[0..256] of char;
  c:byte;
  devObj:TDevObj;
begin
  if (oListe.ItemIndex<0) then exit;
  DevObj := TDevObj(oListe.Items.Objects[oListe.ItemIndex]);
  hUSB := usb_open( DevObj.hDev );
  if ( hUSB <> nil ) then begin

  //be sitos bybienes neveikia!
  c:= ord(edText.Text[1]);

    usb_control_msg(hUSB,  USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, CMD_LCDUSB_CMD, $0F, 0, buffer, 0, 1000);
    usb_close( hUSB );
	end;
end;
end.

